import { Injectable } from '@angular/core';
import { DataProvider } from './data-provider';
import { OdooProvider } from './odoo-provider';
import { NetworkProvider } from './network-provider'

@Injectable()    
export class SyncProvider {

    constructor(
        public dataProvider: DataProvider,
        public odooProvider: OdooProvider
    ) { }

    /**
     *
     */
    doSync(): Promise<any> {
        return new Promise((resolve, reject) => {
            // this.getProductsForUpdate().then(p => {
            //     console.log(p);
            //     resolve();
            // }).catch(e => {
            //     console.log(e);
            //     reject(e);
            // });
            this.odooProvider.get("products").subscribe(data => {
                console.log(data);
                resolve();
            }, err => {
                reject();
            });
        });
    }

    /**
     *
     */
    private getProductsForUpdate(): Promise<any> {
        return new Promise((resolve, reject) => {
            this.dataProvider.getAll("product").then(r => {
                resolve(r.products.filter(item => {
                    return item;
                }));
            }).catch(e => {
                reject(e);
            });
        });
    }
}